#property copyright "Copyright  2010, MP"
#property link      "http://www.metaquotes.net"

//----
#property indicator_separate_window
#property indicator_buffers 1    // number of indicators to plot
#property indicator_color1 DarkGreen   



//---- input parameters
extern int IFFPeriod = 5;
extern int smooth = 9;

//---- buffers

double Value1,Value2,Value3[],Value4,Value5; //Value3 is just needed for calculation

double IFS[]; // to plot


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(2); // Total buffers needed to calculate
   
   IndicatorDigits(2); // number of decimals to show
   IndicatorShortName("IFCycle"); // for window display name
   
   SetLevelStyle(STYLE_DOT,1,DeepSkyBlue);
   SetLevelValue(0,0.50);
   SetLevelValue(1,-0.50);
   
     
   SetIndexBuffer(0,IFS);
   SetIndexStyle(0, DRAW_LINE,STYLE_SOLID,2);
   SetIndexDrawBegin(0,IFS);  
   SetIndexLabel (0,"IFS");
  
   // additional buffers required for computation
  
   SetIndexBuffer (1, Value3);
   
     
    
    return(0);
   }
//-------------END OF init()-----------

int deinit()  
   {   
   return(0);
   }


int start()
  {
         
    int i, limit ;
     int counted_bars=IndicatorCounted();
  //---- check for possible errors
     if(counted_bars<0) return(-1);
  //---- the last counted bar will be recounted
     if(counted_bars>0) counted_bars--;
     limit=Bars-IndicatorCounted();
  //---- main loop

   for(i=0; i<limit; i++)                   
   {
    Value1= iRSI(NULL,0,IFFPeriod,PRICE_CLOSE, i);
    Value2 = 0.1* (Value1-50);
    Value3[i] = Value2 ;
    
    
    
    Value4 = iMAOnArray(Value3,Bars,smooth,0,MODE_LWMA,i);
       
    Value5=(MathExp(2*Value4)-1)/(MathExp(2*Value4)+1);
      
      
    IFS[i] = Value5;
    }
      
      
   
   
  
   return(0);

  }

//+-------------------------------------------------------------------+